Put blob
Stores the request body as one blob and returns its CID. The blob is stored under multicodec_code, or 0x55 (raw binary) when none is given. Requires create_declarations or create_comments in at least one project.
put
https://<host>/store/v1/blobbash
curl --request PUT \
--url 'https://<host>/store/v1/blob' \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/octet-stream' \
--data-binary '@<file>'javascript
const response = await fetch("https://<host>/store/v1/blob", {
method: "PUT",
headers: {
"Authorization": "Bearer <token>",
"Content-Type": "application/octet-stream"
},
body: file
});
const data = await response.json();typescript
declare const file: Blob;
interface PutResponse {
cid: string;
}
const response = await fetch("https://<host>/store/v1/blob", {
method: "PUT",
headers: {
"Authorization": "Bearer <token>",
"Content-Type": "application/octet-stream"
},
body: file
});
if (!response.ok) throw new Error(`${response.status} ${response.statusText}`);
const data: PutResponse = await response.json();python
import requests
response = requests.put(
"https://<host>/store/v1/blob",
headers={
"Authorization": "Bearer <token>",
"Content-Type": "application/octet-stream",
},
data=open("<file>", "rb"),
)
response.raise_for_status()
print(response.json())go
package main
import (
"fmt"
"io"
"net/http"
"os"
)
func main() {
body, err := os.Open("<file>")
if err != nil {
panic(err)
}
defer body.Close()
req, err := http.NewRequest(http.MethodPut, "https://<host>/store/v1/blob", body)
if err != nil {
panic(err)
}
req.Header.Set("Authorization", "Bearer <token>")
req.Header.Set("Content-Type", "application/octet-stream")
res, err := http.DefaultClient.Do(req)
if err != nil {
panic(err)
}
defer res.Body.Close()
data, err := io.ReadAll(res.Body)
if err != nil {
panic(err)
}
fmt.Println(res.Status, string(data))
}java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.nio.file.Path;
public class Example {
public static void main(String[] args) throws Exception {
HttpRequest request = HttpRequest.newBuilder()
.uri(URI.create("https://<host>/store/v1/blob"))
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/octet-stream")
.method("PUT", HttpRequest.BodyPublishers.ofFile(Path.of("<file>")))
.build();
HttpResponse<String> response = HttpClient.newHttpClient()
.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.statusCode() + " " + response.body());
}
}csharp
using System.Net.Http.Headers;
using var client = new HttpClient();
using var request = new HttpRequestMessage(HttpMethod.Put, "https://<host>/store/v1/blob");
request.Headers.Authorization = new AuthenticationHeaderValue("Bearer", "<token>");
request.Content = new StreamContent(File.OpenRead("<file>"));
request.Content.Headers.ContentType = new MediaTypeHeaderValue("application/octet-stream");
using var response = await client.SendAsync(request);
Console.WriteLine($"{(int)response.StatusCode} {await response.Content.ReadAsStringAsync()}");php
<?php
$ch = curl_init('https://<host>/store/v1/blob');
curl_setopt_array($ch, [
CURLOPT_CUSTOMREQUEST => 'PUT',
CURLOPT_HTTPHEADER => [
'Authorization: Bearer <token>',
'Content-Type: application/octet-stream',
],
CURLOPT_POSTFIELDS => file_get_contents('<file>'),
CURLOPT_RETURNTRANSFER => true,
]);
$response = curl_exec($ch);
$status = curl_getinfo($ch, CURLINFO_RESPONSE_CODE);
echo $status . " " . $response . PHP_EOL;ruby
require "net/http"
uri = URI("https://<host>/store/v1/blob")
request = Net::HTTP::Put.new(uri)
request["Authorization"] = "Bearer <token>"
request["Content-Type"] = "application/octet-stream"
request.body = File.binread("<file>")
response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == "https") do |http|
http.request(request)
end
puts "#{response.code} #{response.body}"rust
// Cargo.toml dependencies: reqwest, tokio (features "full")
#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
let response = reqwest::Client::new()
.put("https://<host>/store/v1/blob")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/octet-stream")
.body(std::fs::read("<file>")?)
.send()
.await?;
println!("{} {}", response.status(), response.text().await?);
Ok(())
}Authorizations
BearerAuth· HTTP bearer (JWT)
Parameters
Query parameters
| Name | Type | Description |
|---|---|---|
multicodec_code | integer<int64> | null | Multicodec of the blob's CID; 0x55 (raw binary) when omitted |
Request bodyrequired
application/octet-stream
string<binary>
Responses
200The stored blob's CID
application/json
cidstringrequired
Examplejson
{
"cid": "string"
}401Missing or invalid bearer token
application/json
callstackobjectShow properties
object | nullerrorstringrequired
Examplejson
{
"callstack": {},
"error": "string"
}403Caller holds neither create_declarations nor create_comments in any project
application/json
callstackobjectShow properties
object | nullerrorstringrequired
Examplejson
{
"callstack": {},
"error": "string"
}500Internal error
application/json
callstackobjectShow properties
object | nullerrorstringrequired
Examplejson
{
"callstack": {},
"error": "string"
}503Auth Service or blob storage unavailable
application/json
callstackobjectShow properties
object | nullerrorstringrequired
Examplejson
{
"callstack": {},
"error": "string"
}